"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _checkExamples = _interopRequireDefault(require("./rules/checkExamples"));

var _checkParamNames = _interopRequireDefault(require("./rules/checkParamNames"));

var _checkTagNames = _interopRequireDefault(require("./rules/checkTagNames"));

var _checkTypes = _interopRequireDefault(require("./rules/checkTypes"));

var _newlineAfterDescription = _interopRequireDefault(require("./rules/newlineAfterDescription"));

var _noUndefinedTypes = _interopRequireDefault(require("./rules/noUndefinedTypes"));

var _requireDescriptionCompleteSentence = _interopRequireDefault(require("./rules/requireDescriptionCompleteSentence"));

var _requireDescription = _interopRequireDefault(require("./rules/requireDescription"));

var _requireExample = _interopRequireDefault(require("./rules/requireExample"));

var _requireHyphenBeforeParamDescription = _interopRequireDefault(require("./rules/requireHyphenBeforeParamDescription"));

var _requireParamName = _interopRequireDefault(require("./rules/requireParamName"));

var _requireParam = _interopRequireDefault(require("./rules/requireParam"));

var _requireParamDescription = _interopRequireDefault(require("./rules/requireParamDescription"));

var _requireParamType = _interopRequireDefault(require("./rules/requireParamType"));

var _requireReturns = _interopRequireDefault(require("./rules/requireReturns"));

var _requireReturnsCheck = _interopRequireDefault(require("./rules/requireReturnsCheck"));

var _requireReturnsDescription = _interopRequireDefault(require("./rules/requireReturnsDescription"));

var _requireReturnsType = _interopRequireDefault(require("./rules/requireReturnsType"));

var _validTypes = _interopRequireDefault(require("./rules/validTypes"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* eslint-disable import/max-dependencies */
var _default = {
  configs: {
    recommended: {
      rules: {
        'jsdoc/check-examples': 'off',
        'jsdoc/check-param-names': 'warn',
        'jsdoc/check-tag-names': 'warn',
        'jsdoc/check-types': 'warn',
        'jsdoc/newline-after-description': 'warn',
        'jsdoc/no-undefined-types': 'warn',
        'jsdoc/require-description': 'off',
        'jsdoc/require-description-complete-sentence': 'off',
        'jsdoc/require-example': 'off',
        'jsdoc/require-hyphen-before-param-description': 'off',
        'jsdoc/require-param': 'warn',
        'jsdoc/require-param-description': 'warn',
        'jsdoc/require-param-name': 'warn',
        'jsdoc/require-param-type': 'warn',
        'jsdoc/require-returns': 'warn',
        'jsdoc/require-returns-check': 'warn',
        'jsdoc/require-returns-description': 'warn',
        'jsdoc/require-returns-type': 'warn',
        'jsdoc/valid-types': 'warn'
      }
    }
  },
  rules: {
    'check-examples': _checkExamples.default,
    'check-param-names': _checkParamNames.default,
    'check-tag-names': _checkTagNames.default,
    'check-types': _checkTypes.default,
    'newline-after-description': _newlineAfterDescription.default,
    'no-undefined-types': _noUndefinedTypes.default,
    'require-description': _requireDescription.default,
    'require-description-complete-sentence': _requireDescriptionCompleteSentence.default,
    'require-example': _requireExample.default,
    'require-hyphen-before-param-description': _requireHyphenBeforeParamDescription.default,
    'require-param': _requireParam.default,
    'require-param-description': _requireParamDescription.default,
    'require-param-name': _requireParamName.default,
    'require-param-type': _requireParamType.default,
    'require-returns': _requireReturns.default,
    'require-returns-check': _requireReturnsCheck.default,
    'require-returns-description': _requireReturnsDescription.default,
    'require-returns-type': _requireReturnsType.default,
    'valid-types': _validTypes.default
  }
};
exports.default = _default;
module.exports = exports.default;
//# sourceMappingURL=index.js.map