"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _lodash = _interopRequireDefault(require("lodash"));

var _iterateJsdoc = _interopRequireDefault(require("../iterateJsdoc"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _default = (0, _iterateJsdoc.default)(function (_ref) {
  var jsdoc = _ref.jsdoc,
      report = _ref.report,
      utils = _ref.utils;
  var targetTagName = utils.getPreferredTagName('example');

  var functionExamples = _lodash.default.filter(jsdoc.tags, {
    tag: targetTagName
  });

  if (_lodash.default.isEmpty(functionExamples)) {
    return report('Missing JSDoc @' + targetTagName + ' declaration.');
  }

  return _lodash.default.forEach(functionExamples, function (example) {
    var exampleContent = _lodash.default.compact((example.name + ' ' + example.description).trim().split('\n'));

    if (_lodash.default.isEmpty(exampleContent)) {
      report('Missing JSDoc @' + targetTagName + ' description.');
    }
  });
});

exports.default = _default;
module.exports = exports.default;
//# sourceMappingURL=requireExample.js.map