"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _lodash = _interopRequireDefault(require("lodash"));

var _iterateJsdoc = _interopRequireDefault(require("../iterateJsdoc"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _default = (0, _iterateJsdoc.default)(function (_ref) {
  var sourceCode = _ref.sourceCode,
      jsdoc = _ref.jsdoc,
      report = _ref.report,
      jsdocNode = _ref.jsdocNode;

  var jsdocTags = _lodash.default.filter(jsdoc.tags, {
    tag: 'param'
  });

  _lodash.default.forEach(jsdocTags, function (jsdocTag) {
    if (jsdocTag.description && !_lodash.default.startsWith(jsdocTag.description, '-')) {
      report('There must be a hyphen before @param description.', function (fixer) {
        var replacement = sourceCode.getText(jsdocNode).replace(jsdocTag.description, '- ' + jsdocTag.description);
        return fixer.replaceText(jsdocNode, replacement);
      }, jsdocTag);
    }
  });
});

exports.default = _default;
module.exports = exports.default;
//# sourceMappingURL=requireHyphenBeforeParamDescription.js.map