"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _lodash = _interopRequireDefault(require("lodash"));

var _iterateJsdoc = _interopRequireDefault(require("../iterateJsdoc"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _default = (0, _iterateJsdoc.default)(function (_ref) {
  var jsdoc = _ref.jsdoc,
      report = _ref.report,
      utils = _ref.utils;
  var targetTagName = utils.getPreferredTagName('param');

  var jsdocParameters = _lodash.default.filter(jsdoc.tags, {
    tag: targetTagName
  });

  _lodash.default.forEach(jsdocParameters, function (jsdocParameter) {
    if (!jsdocParameter.type) {
      report('Missing JSDoc @' + targetTagName + ' "' + jsdocParameter.name + '" type.', null, jsdocParameter);
    }
  });
});

exports.default = _default;
module.exports = exports.default;
//# sourceMappingURL=requireParamType.js.map