"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _lodash = _interopRequireDefault(require("lodash"));

var _iterateJsdoc = _interopRequireDefault(require("../iterateJsdoc"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _default = (0, _iterateJsdoc.default)(function (_ref) {
  var jsdoc = _ref.jsdoc,
      report = _ref.report,
      utils = _ref.utils;
  var targetTagName = utils.getPreferredTagName('returns');

  var jsdocTags = _lodash.default.filter(jsdoc.tags, {
    tag: targetTagName
  });

  var sourcecode = utils.getFunctionSourceCode();
  var voidReturn = jsdocTags.findIndex(function (vundef) {
    return ['undefined', 'void'].indexOf(vundef.type) !== -1;
  }) === -1;

  if (JSON.stringify(jsdocTags) !== '[]' && voidReturn && sourcecode.indexOf('return') < 1) {
    report('Present JSDoc @' + targetTagName + ' declaration but not available return expression in function.');
  }
});

exports.default = _default;
module.exports = exports.default;
//# sourceMappingURL=requireReturnsCheck.js.map